% Draw figure D1b -noise2
% Protein Production-5 states

t_fin=15;
Nt=15;
global u_vector % vector global cu eval_fi 
global t_vector % vector global cu prog principal
global command_index;

X00=[0. 0. 1. 5. 1.];
uML2=[0.1570 0.2842 0.3744 0.3296 0.6528 0.7238 1.2591...
    1.4624 1.5555 2.0000 0.1898 0.8700 0.9106 0.9412 1.1815];
ustar= uML2;

%Afisare evolutie sistem in executie tipica
t=0:1:Nt; %are Nt+1 elemente
%**************************************************************
%Global simulation
u_vector=[ustar(1:Nt),ustar(Nt)];
t_vector=0:t_fin;
figure(4)
stairs(t_vector,u_vector,'r');
title('Control profile - with linear regression');
xlabel('time [h]');
ylabel('control output: u ');
axis([0,15,0.,2.]);
grid MINOR;


command_index=1;
%options = odeset('RelTol',1e-3,'MaxStep',1.5);
[T,Y] = ode23('PRProd',t_vector,X00);

figure(5)
plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
title('State evolution - with linear regression');
axis([0,15,0.,14.]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{3x}_{1}','\it{3x}_{2}','\it{3x}_{3}','\it{x}_{4}','\it{x}_{5}','Location','NorthWest');

grid MINOR;
%**********************


