% New article: mdpi-Processes
% Special Issue:
% This script generate the trained NN models for each sampling
% period (120 models) using the DATAKTrain and DATAKTest tables.
tic
load('WS_Modelsv1','MODEL','DATAKTest','DATAKTrain');
MODELNN=cell(120,1); %Construct the array cell

% Create the NN modelfor k=0, i.e. klpus1=1
% There is a single predictor called x1, because x2=0
kplus1=1;
datakTrain0=DATAKTrain{1}; 
datakTest0=DATAKTest{1};
[mdlNN0,vrmse]=trainRegNNK0(datakTrain0);
MODELNN{kplus1}=mdlNN0;
    uPredValid0=mdlNN0.predictFcn(datakTest0);
    RMSEValid=rmse(uPredValid0,datakTest0.u);
    fprintf('&&& vrmse=%8.4f RMSEValid=%8.4f\n',vrmse,RMSEValid);
%Prediction  test  
    stare=datakTest0{10,1};
    sT=array2table(stare);
    sT=renamevars(sT,"stare","x1");
    uNN=mdlNN0.predictFcn(sT);
    valreal=datakTest0{10,2};
    fprintf('kplus1=%2d uNN=%8.4f valreal=%8.4f\n\n',kplus1,uNN,valreal);
    
%disp('**************');
for kplus1=2:120
    datakTrain=DATAKTrain{kplus1};
    datakTest=DATAKTest{kplus1};
    [mdlNN,vrmse]=trainRegNN(datakTrain);
    
    MODELNN{kplus1}=mdlNN;

    uPredValid=mdlNN.predictFcn(datakTest);
    RMSEValid=rmse(uPredValid,datakTest.u);
    fprintf('&&& vrmse=%8.4f RMSEValid=%8.4f\n',vrmse,RMSEValid);
 
    %Prediction test    
    stare=datakTest{10,1:2}; % Record #10
    sT=array2table(stare);
    sT=renamevars(sT,["stare1" "stare2"],["x1" "x2"]);
    uNN=mdlNN.predictFcn(sT);
    valreal=datakTest{10,3};
    fprintf('kplus1=%2d uNN=%8.4f valreal=%8.4f\n\n',kplus1, uNN,valreal);
  
end
toc
%save('WS_ModelsRNN','MODELNN','DATAKTest','DATAKTrain');

%mdlNN1=MODELNN{5};
% datakTest=DATAKTest{5};
% stare=datakTest{10,1:2};
%     sT=array2table(stare);
%     sT=renamevars(sT,["stare1" "stare2"],["x1" "x2"]);
%     uNN=mdlNN1.predictFcn(sT);
%     valreal=datakTest{10,3};
%    fprintf('&&&  uNN=%8.4f valreal=%8.4f\n\n',uNN,valreal);
